' Debug.ascx 1.2
' Debug Information Class - Adds "missing" features to .NET's trace panel & makes is easier to use.
' Written by Hunter Beanland - hbeanland@yahoo.com.au
' http://www.geocities.com/hbeanland/web/net.htm 
Imports Microsoft.VisualBasic
Imports System
Imports System.Web
Imports System.Text
Imports System.Collections
Imports System.Web.UI.StateBag

Public MustInherit Class Debug
    Inherits System.Web.UI.UserControl
    Protected WithEvents dbgPanel As System.Web.UI.HtmlControls.HtmlGenericControl
    Protected WithEvents dbgSections As System.Web.UI.WebControls.Literal
    Protected WithEvents dbgScript As System.Web.UI.WebControls.Literal
    Private sb As StringBuilder = New StringBuilder()
    Private intCount As Integer = 0
    Private DebugDir As String = "" '"/Controls/"
#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Trace.IsEnabled Or InStr(Session("Security"), "DV") > 0 Then
            dbgPanel.EnableViewState = False
            dbgScript.Text = "<script language='javascript'>divID=""" & dbgPanel.ClientID & """;</script>"
            'Build section index
            BuildIndex()
            'JS debugger
            AddSection("JavaScript Debugger:", "120")
            AddItem("Action:", "<a href=""javascript:dbgTesterExecute();"">Execute</a>&nbsp;/&nbsp;<a href=""javascript:dbgObjectDump('');"">Show Object</a>")
            AddItem("Statement/Object:", "<textarea name='MyCommand' cols='80' rows='2' wrap='off'>document</textarea>")
            AddItem("Result:", "<span id='MyResult'></span>")

            If Not Trace.IsEnabled Then
                'Generally production mode - no trace
                Dim CollectionItem As String
                AddSection("General:", "100")
                AddItem("Now", Now.ToString)
                AddItem("Method", Request.ServerVariables("REQUEST_METHOD"))
                AddItem("Status", Response.Status)
                AddItem("Request Encoding", Request.ContentEncoding.EncodingName)
                AddItem("Response Encoding", Response.ContentEncoding.EncodingName)
                AddItem("", "<a href='" & DebugDir & "debug-info.aspx#browser' target='_blank'>Browser Info</a>")

                AddSection("Query String:", "101")
                For Each CollectionItem In Request.QueryString
                    AddItem(CollectionItem, Request.QueryString(CollectionItem))
                Next

                AddSection("Form:", "102")
                For Each CollectionItem In Request.Form
                    If CollectionItem = "__VIEWSTATE" Then
                        AddItem(CollectionItem, "...")
                    Else
                        AddItem(CollectionItem, Request.Form(CollectionItem))
                    End If
                Next

                AddSection("Trace:", "2")
                'Array "DebugTrace" in the Session comes from a custom logger component
                If Not Session("DebugTrace") Is Nothing Then
                    Dim intLoop As Integer
                    Dim aryTrace(,) As String = Session("DebugTrace")
                    For intLoop = 0 To UBound(aryTrace, 2)
                        AddItem(aryTrace(0, intLoop), aryTrace(1, intLoop))
                    Next
                End If

                AddSection("Session:", "103")
                For Each CollectionItem In Session.Contents
                    Try
                        AddItem(CollectionItem, Session.Contents(CollectionItem))
                    Catch
                        AddItem(CollectionItem, ":???")
                    End Try
                Next
                AddItem("---------------", "")
                SessionItems()
                AddItem("Session ID", Session.SessionID)

                AddSection("Application:", "104")
                For Each CollectionItem In Application.Contents
                    Try
                        If Not IsArray(Application.Contents(CollectionItem)) Then AddItem(CollectionItem, Application.Contents(CollectionItem).ToString)
                    Catch
                        If Not IsArray(Application.Contents(CollectionItem)) Then AddItem(CollectionItem, CollectionItem & ":???")
                    End Try
                Next

                AddSection("Cookies:", "105")
                For Each CollectionItem In Request.Cookies
                    AddItem(CollectionItem, Request.Cookies(CollectionItem).Value)
                Next

                AddSection("Server Variables:", "106")
                For Each CollectionItem In Request.ServerVariables
                    If CollectionItem <> "ALL_HTTP" And CollectionItem <> "ALL_RAW" And Request.ServerVariables(CollectionItem) <> "" Then AddItem(CollectionItem, Request.ServerVariables(CollectionItem))
                Next
            Else
                'Development/trace/localhost mode
                '   Page classes ViewState not readable from here. How to do it?
                '    AddSection("ViewState Info:", "111")
                '    Dim objStateItem As System.Web.UI.StateItem
                '    Dim objStateBag As New System.Web.UI.StateBag()
                '    For Each objStateItem In objStateBag
                '        AddItem(objStateItem.ToString, objStateItem.Value.ToString)
                '    Next
                '    Dim objStateEntry As System.Collections.DictionaryEntry
                '    For Each objStateEntry In Me.ViewState
                '        AddItem(objStateEntry.Key.ToString, ViewState(objStateEntry.Key))
                '    Next

                AddSection("Session Info:", "103")
                SessionItems()
                AddItem("", "<a href='" & DebugDir & "debug-info.aspx#browser' target='_blank'>Browser Info</a>")
            End If

            AddSection("Web Server:", "107")
            Dim objCurrentInfo As System.Web.ProcessInfo = ProcessModelInfo.GetCurrentProcessInfo()
            AddItem("Machine Name:", Server.MachineName)
            AddItem("OS Version:", Environment.OSVersion.ToString())
            AddItem("CLR Version:", Environment.Version.ToString())
            AddItem("StartTime:", objCurrentInfo.StartTime & " (" & _
                objCurrentInfo.Age.Days & " days, " & objCurrentInfo.Age.Hours & ":" & objCurrentInfo.Age.Minutes & " hours)")
            AddItem("", "<a href='" & DebugDir & "debug-info.aspx' target='_blank'>Statistics</a>")

            dbgSections.Text = sb.ToString & "</table>"
            dbgPanel.Visible = True
        End If
        If Not Session("DebugTrace") Is Nothing Then Session.Remove("DebugTrace")
   End Sub

    Sub AddItem(ByVal strName, ByVal strContent)
        intCount += 1
        If intCount Mod 2 > 0 Then
            sb.Append("<tr><td class='dbgHeaderAlt' valign='top' width='20%'>" & strName & "</td><td class='dbgRowAlt'>" & strContent & "</td></tr>" & vbLf)
        Else
            sb.Append("<tr><td class='dbgHeader' valign='top'>" & strName & "</td><td>" & strContent & "</td></tr>" & vbLf)
        End If
    End Sub

    Sub AddSection(ByVal strName, ByVal strIndex)
        If strIndex <> "120" Then sb.Append("</table>")
        sb.Append("<table id='dbg" & strIndex & "' width='100%' cellspacing='0' border='0' class='dbgText'>" & vbLf)
        sb.Append("<tr><td class='dbgDivSetsHeader' colspan='2'>" & strName & "</td></tr>" & vbLf)
        intCount = 0
    End Sub

    Sub SessionItems()
        If Not (HttpContext.Current.User Is Nothing) Then
            AddItem("Forms Authentication:", HttpContext.Current.User.Identity.Name & IIf(HttpContext.Current.User.Identity.IsAuthenticated, " (Authenticated)", ""))
        End If
        AddItem("Culture:", System.Threading.Thread.CurrentThread.CurrentCulture.Name)
        AddItem("Code Page:", Session.CodePage.ToString)
        AddItem("LCID:", "0x" & Hex(Session.LCID))
        AddItem("Cookieless:", Session.IsCookieless)
        AddItem("New Session:", Session.IsNewSession)
        AddItem("Synchronized:", Session.IsSynchronized)
        AddItem("Timeout:", Session.Timeout & " min")
        AddItem("Script Timeout:", Server.ScriptTimeout / 60 & " min")
    End Sub

    Sub BuildIndex()
        sb.Append("<table id='dbgSelect' class='dbgText' width='100%' cellspacing='2' border='0'>")
        sb.Append("<tr class='dbgDivSetsHeader' style='FONT-WEIGHT: bold;'>")
        sb.Append("<td colspan='10'><a href='javascript:dbgHidePanels();' style='font-family:wingdings,arial;color:white;'>x</a> DEBUG PANEL</td>")
        sb.Append("</tr><tr class='dbgHeaderAlt'>" & vbLf)
        sb.Append("<td align='center'><a href='javascript:dbgShowSection(0);'>Show All</a></td>")
        sb.Append("<td align='center'><a href='javascript:dbgShowSection(99);'>Show None</a></td>")
        sb.Append("<td align='center'><a href='javascript:dbgShowSection(120);'>JS Debugger</a></td>")
        If Trace.IsEnabled Then
            'Development mode
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(103);'>Session Info</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(107);'>Web Server</a></td>")
            sb.Append("<td colspan='5'></td></tr><tr class='dbgHeaderAlt'>" & vbLf)
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(1);'>Request</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(2);'>Trace</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(3);'>Control Tree</a></td>")
            intCount = 4
            If Session.Count > 0 Then
                sb.Append("<td align='center'><a href='javascript:dbgShowSection(4);'>Session</a></td>")
                intCount += 1
            End If
            If Application.Count > 0 Then
               sb.Append("<td align='center'><a href='javascript:dbgShowSection(" & intCount & ");'>Application</a></td>")
               intCount += 1
            End If
            If Request.Cookies.Count > 0 Then
               sb.Append("<td align='center'><a href='javascript:dbgShowSection(" & intCount & ");'>Cookies</a></td>")
               intCount += 1
            End If
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(" & intCount & ");'>Headers</a></td>")
            intCount += 1
            If Request.Form.Count > 0 Then
               sb.Append("<td align='center'><a href='javascript:dbgShowSection(" & intCount & ");'>Form</a></td>")
               intCount += 1
            End If
            If Request.QueryString.Count > 0 Then
               sb.Append("<td align='center'><a href='javascript:dbgShowSection(" & intCount & ");'>QueryString</a></td>")
               intCount += 1
            End If
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(" & intCount & ");'>ServerVars</a></td>")
        Else
            'Developer in production mode
            sb.Append("<td colspan='5'></td></tr><tr class='dbgHeaderAlt'>" & vbLf)
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(100);'>General</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(101);'>QueryString</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(102);'>Form</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(2);'>Trace</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(103);'>Session</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(104);'>Application</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(105);'>Cookies</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(106);'>ServerVars</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(107);'>Web Server</a></td>")
        End If
        sb.Append("</tr></table>")
    End Sub


End Class
