' Debug.ascx 1.35
' Debug Panel Information Class - Adds "missing" features to .NET 2's trace panel & makes is easier to use.
' Written by Hunter Beanland
Imports Microsoft.VisualBasic
Imports System
Imports System.Web
Imports System.Text
Imports System.Collections
Imports System.Web.UI.StateBag

Partial Class DebugPanel

    Inherits System.Web.UI.UserControl
    Private sb As StringBuilder = New StringBuilder()
    Private intCount As Integer = 0
    Private DebugDir As String = "/Programming/dotnet/Debug/" '"/Controls/" '**** Change this to your own folder
#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Trace.IsEnabled Or Session("Dev") Then 'User.IsInRole("Dev") '**** Change this to your own security system
            dbgPanel.EnableViewState = False
            dbgScript.Text = "<script type=""text/javascript"">divID=""" & dbgPanel.ClientID & """;</script>"
            'Build section index
            BuildIndex()
            'JS debugger
            AddSection("JavaScript Debugger:", "120")
            AddItem("Action:", "<a href=""javascript:dbgTesterExecute();"">Execute</a>&nbsp;/&nbsp;<a href=""javascript:dbgObjectDump('');"">Show Object</a>")
            AddItem("Statement/Object:", "<textarea id='dbgMyCommand' cols='80' rows='2' wrap='off'>document</textarea>")
            AddItem("Result:", "<span id='MyResult'></span>")

            'Dim CollectionItem2 As String
            'AddSection("Profile:", "101")
            'For Each CollectionItem2 In Profile.PropertyValues
            '    'AddItem("Name", Profile.UserName)
            '    'AddItem("No", Profile.UserNo)
            '    AddItem(CollectionItem2, Profile.Item(CollectionItem2))
            'Next

            If Not Trace.IsEnabled Then
                'Generally production mode - no trace
                Dim CollectionItem As String
                AddSection("General:", "100")
                AddItem("Now", Now.ToString)
                AddItem("Method", Request.ServerVariables("REQUEST_METHOD"))
                AddItem("Status", Response.Status)
                AddItem("Request Encoding", Request.ContentEncoding.EncodingName)
                AddItem("Response Encoding", Response.ContentEncoding.EncodingName)
                AddItem("ViewState", "<span id='dbgViewState'></span>&nbsp;bytes")
                AddItem("", "<a href='" & DebugDir & "debug-info.aspx#browser' target='_blank'>Browser Info</a>")

                AddSection("Trace:", "2")
                'Array "DebugTrace" in the Session comes from a custom logger component
                If Not Session("DebugTrace") Is Nothing Then
                    Dim aryTrace(,) As String = Session("DebugTrace")
                    For intLoop As Int16 = 0 To UBound(aryTrace, 2)
                        AddItem(aryTrace(0, intLoop) & " - " & aryTrace(2, intLoop), aryTrace(1, intLoop))
                    Next
                End If

                AddSection("Query String:", "101")
                For Each CollectionItem In Request.QueryString
                    AddItem(CollectionItem, Request.QueryString(CollectionItem))
                Next

                AddSection("Form:", "102")
                For Each CollectionItem In Request.Form
                    If CollectionItem = "__VIEWSTATE" Then
                        AddItem(CollectionItem, "...")
                    Else
                        AddItem(CollectionItem, Request.Form(CollectionItem))
                    End If
                Next

                AddSection("Session:", "103")
                For Each CollectionItem In Session.Contents
                    Try
                        AddItem(CollectionItem, Session.Contents(CollectionItem))
                    Catch
                        AddItem(CollectionItem, ":???")
                    End Try
                Next
                AddItem("---------------", "")
                SessionItems()
                AddItem("Session ID", Session.SessionID)

                AddSection("Application:", "104")
                For Each CollectionItem In Application.Contents
                    Try
                        If Not IsArray(Application.Contents(CollectionItem)) Then AddItem(CollectionItem, Application.Contents(CollectionItem).ToString)
                    Catch
                        If Not IsArray(Application.Contents(CollectionItem)) Then AddItem(CollectionItem, CollectionItem & ":???")
                    End Try
                Next

                AddSection("Cookies-Request:", "105")
                For Each CollectionItem In Request.Cookies
                    AddItem(CollectionItem, Request.Cookies(CollectionItem).Value)
                Next

                AddSection("Cookies-Response:", "106")
                For Each CollectionItem In Request.Cookies
                    AddItem(CollectionItem, Request.Cookies(CollectionItem).Value)
                Next

                AddSection("Server Variables:", "107")
                For Each CollectionItem In Request.ServerVariables
                    If CollectionItem <> "ALL_HTTP" And CollectionItem <> "ALL_RAW" And Request.ServerVariables(CollectionItem) <> "" Then AddItem(CollectionItem, Request.ServerVariables(CollectionItem))
                Next
            Else
                'Development/trace/localhost mode
                '   Page classes ViewState not readable from here. How to do it?
                'AddSection("ViewState Info:", "111")
                'Dim objStateEntry As System.Collections.DictionaryEntry
                'For Each objStateEntry In MyBase.ViewState
                '    AddItem(objStateEntry.Key.ToString, objStateEntry.Value) 'MyBase.ViewState(objStateEntry.Key))
                'Next

                AddSection("Session Info:", "103")
                SessionItems()
                AddItem("ViewState", "<span id='dbgViewState'></span>&nbsp;bytes")
                AddItem("", "<a href='" & DebugDir & "debug-info.aspx#browser' target='_blank'>Browser Info</a>")
            End If

            AddSection("Web Server:", "108")
            AddItem("Machine Name:", Server.MachineName)
            AddItem("OS Version:", Environment.OSVersion.ToString())
            AddItem("CLR Version:", Environment.Version.ToString())
            Try
                'IIS6 worker process isolation mode will make this fail
                Dim objCurrentInfo As System.Web.ProcessInfo = ProcessModelInfo.GetCurrentProcessInfo()
                AddItem("StartTime:", objCurrentInfo.StartTime & " (" & _
                    objCurrentInfo.Age.Days & " days, " & objCurrentInfo.Age.Hours & ":" & objCurrentInfo.Age.Minutes & " hours)")
                AddItem("", "<a href='" & DebugDir & "debug-info.aspx' target='_blank'>Statistics</a>")
            Catch
            End Try
            dbgSections.Text = sb.ToString & "</table>"
            dbgPanel.Visible = True
        End If
        If Not Session("DebugTrace") Is Nothing Then Session.Remove("DebugTrace")
    End Sub

    Private Sub AddItem(ByVal strName, ByVal strContent)
        intCount += 1
        If intCount Mod 2 > 0 Then
            sb.Append("<tr><td class='dbgHeaderAlt' valign='top' width='20%'>" & strName & "</td><td class='dbgRowAlt'>" & strContent & "</td></tr>" & vbLf)
        Else
            sb.Append("<tr><td class='dbgHeader' valign='top'>" & strName & "</td><td>" & strContent & "</td></tr>" & vbLf)
        End If
    End Sub

    Private Sub AddSection(ByVal strName, ByVal strIndex)
        If strIndex <> "120" Then sb.Append("</table>")
        sb.Append("<table id='dbg" & strIndex & "' width='100%' cellspacing='0' border='0' class='dbgText'>" & vbLf)
        sb.Append("<tr><td class='dbgDivSetsHeader' colspan='2'>" & strName & "</td></tr>" & vbLf)
        intCount = 0
    End Sub

    Private Sub SessionItems()
        If Not (HttpContext.Current.User Is Nothing) Then
            AddItem("Forms Authentication:", HttpContext.Current.User.Identity.Name & IIf(HttpContext.Current.User.Identity.IsAuthenticated, " (Authenticated)", ""))
        End If
        AddItem("Culture:", System.Threading.Thread.CurrentThread.CurrentCulture.Name)
        AddItem("Code Page:", Session.CodePage.ToString)
        AddItem("LCID:", "0x" & Hex(Session.LCID))
        AddItem("Theme:", Page.Theme)
        AddItem("Mode:", Session.Mode.ToString)
        AddItem("Cookieless:", Session.IsCookieless)
        AddItem("New Session:", Session.IsNewSession)
        AddItem("Synchronized:", Session.IsSynchronized)
        AddItem("Timeout:", Session.Timeout & " min")
        AddItem("Script Timeout:", Server.ScriptTimeout / 60 & " min")
    End Sub

    Private Sub BuildIndex()
        sb.Append("<table id='dbgSelect' class='dbgText' width='100%' cellspacing='2' border='0'>")
        sb.Append("<tr class='dbgDivSetsHeader' style='FONT-WEIGHT: bold;'>")
        sb.Append("<td colspan='12'><a href='javascript:dbgHidePanels();' style='font-family:wingdings,arial;color:white;'>x</a> DEBUG PANEL</td>")
        sb.Append("</tr><tr class='dbgHeaderAlt'>" & vbLf)
        sb.Append("<td align='center'><a href='javascript:dbgShowSection(0);'>Show All</a></td>")
        sb.Append("<td align='center'><a href='javascript:dbgShowSection(99);'>Show None</a></td>")
        sb.Append("<td align='center'><a href='javascript:dbgShowSection(120);'>JS Debugger</a></td>")
        If Trace.IsEnabled Then
            'Development mode
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(103);'>Session Info</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(108);'>Web Server</a></td>")
            sb.Append("<td colspan='5'></td></tr><tr class='dbgHeaderAlt'>" & vbLf)
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(1);'>Request</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(2);'>Trace</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(3);'>Control Tree</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(4);'>Session</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(5);'>Application</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(6);'>Cookies-Req</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(7);'>Cookies-Resp</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(8);'>Headers-Req</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(9);'>Headers-Resp</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(10);'>Form</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(11);'>QueryString</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(12);'>ServerVars</a></td>")
        Else
            'Developer in production mode
            sb.Append("<td colspan='5'></td></tr><tr class='dbgHeaderAlt'>" & vbLf)
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(100);'>General</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(2);'>Trace</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(101);'>QueryString</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(102);'>Form</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(103);'>Session</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(104);'>Application</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(105);'>Cookies-Req</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(106);'>Cookies-Resp</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(107);'>ServerVars</a></td>")
            sb.Append("<td align='center'><a href='javascript:dbgShowSection(108);'>Web Server</a></td>")
        End If
        sb.Append("</tr></table>")
    End Sub


End Class
